namespace Microsoft.ServiceModel.Samples.Discovery
{
    using System;
    using System.Xml;
    using System.ServiceModel;
    using Microsoft.ServiceModel.Samples.Discovery.Protocol;

    internal class ResolveContext : FindContext
    {
        Resolve resolve;

        public ResolveContext(EndpointAddress address, TimeSpan findDuration)
            : this(Resolve.FromEndpointAddress(address), findDuration)
        {
        }

        public ResolveContext(Resolve resolve, TimeSpan findDuration)
            : base(findDuration, 1)
        {
            this.resolve = resolve;
        }

        public Resolve Resolve
        {
            get
            {
                return this.resolve;
            }
        }
    }
}
