namespace Microsoft.ServiceModel.Samples.Discovery
{
    using System;
    using System.Xml;
    using System.Xml.Serialization;
    using System.Collections.Generic;
    using System.Collections.ObjectModel;
    using Microsoft.ServiceModel.Samples.Discovery.Protocol;
    
    [XmlRoot(ElementName = ProtocolStrings.TypesElement,
        Namespace = ProtocolStrings.Namespace)]
    public class ContactTypeCollection : Collection<XmlQualifiedName>, IXmlSerializable
    {
        #region IXmlSerializable Members

        public System.Xml.Schema.XmlSchema GetSchema()
        {
            return null;
        }

        public void ReadXml(XmlReader reader)
        {
            List<XmlQualifiedName> qnames = 
                SerializationUtility.ReadContentAsListOfQNames(reader);

            reader.ReadEndElement();

            // update current values
            this.Clear();
            foreach (XmlQualifiedName qname in qnames)
                this.Add(qname);
        }

        public void WriteXml(XmlWriter writer)
        {
            SerializationUtility.WriteListOfQNames(writer, this);
        }

        #endregion
    }
}
