namespace Microsoft.ServiceModel.Samples.Discovery.Protocol
{
    using System;
    using System.ServiceModel.Channels;

    public class OutputBinding
    {
        Binding binding;
        Uri viaUri;
        Uri toUri;

        public OutputBinding(Binding binding, Uri viaUri)
            : this(binding, viaUri, new Uri(ProtocolStrings.DiscoveryAddress))
        {
        }

        public OutputBinding(Binding binding, Uri viaUri, Uri toUri)
        {
            if (binding == null)
                throw new ArgumentNullException("binding");

            if (viaUri == null)
                throw new ArgumentNullException("viaUri");

            if (toUri == null)
                throw new ArgumentNullException("toUri");

            this.binding = binding;
            this.viaUri = viaUri;
            this.toUri = toUri;
        }

        public Binding Binding
        {
            get
            {
                return this.binding;
            }

            set
            {
                if (value == null)
                    throw new ArgumentNullException("value");

                this.binding = value;
            }
        }

        public Uri ViaUri
        {
            get
            {
                return this.viaUri;
            }

            set
            {
                if (value == null)
                    throw new ArgumentNullException("value");

                this.viaUri = value;
            }
        }

        public Uri ToUri
        {
            get
            {
                return this.toUri;
            }

            set
            {
                if (value == null)
                    throw new ArgumentNullException("value");

                this.toUri = value;
            }
        }
    }
}
